<?php if( ! defined( "BASEPATH" ) ) die( "Direct call not allowed" );
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  MYSE - Make your site easy
//  Copyright 2014 SakerSoft
//  All Rights Reserved.
//
//	This software is a property of SakerSoft. Any redistribution or
//	reproduction of part or all of the contents in any form is prohibited.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Class Payment_Mobilpay
 *
 * @version 1.0.0
 */
class Payment_Mobilpay extends BPayment_type
{
    protected $available_types  = array(
                                    "sms",
                                    "card"
                                );
    protected $payment_method_type;
    protected $enc_data         = "";
    protected $env_key          = "";

    public function __construct()
    {
        $this->type = "mobilpay";

        parent::__construct();

        Logger_helper::Debug( "Mobilpay payment class initialized" );
    }

    public function Set_express_checkout_details( & $order )
    {
        if( ! $this->is_on )
        {
            Logger_helper::Info( "PayU payment - setting express checkout error because is turned off" );

            return FALSE;
        }

        Logger_helper::Debug( "Mobilpay payment - setting express checkout, getting the token" );

        if( empty( $order->payment_method_type ) || ! in_array( $order->payment_method_type, $this->available_types ) )
        {
            $order->payment_method_type = "card";
        }

        // Call the method for selected payment type
        $this->Generate_data( $order );

        $this->status           = TRUE;
        $this->correlation_id	= "Success";
        $this->token	        = "Success";

        return $this->Get_status();
    }

    private function Generate_data( & $order )
    {
        $payment_url  = Variable_helper::Has_value( $this->config, "checkout_url" );
        $type         = $this->payment_method_type;
        if( empty( $type ) )
        {
            $type = "card";
        }

        Logger_helper::Info( "Mobilpay payment - starting to generate data for type: ".$type );

        $public_key = BASEPATH.Variable_helper::Has_value( $this->config, $type."_public_key_file" );
        $signature  = Variable_helper::Has_value( $this->config, $type."_signature" );
        $returnUrl  = Variable_helper::Has_value( $this->all_config, "express_checkout_success_url" );
        $cancelUrl  = Variable_helper::Has_value( $this->all_config, "express_checkout_cancel_url" );
        $confirmUrl = Variable_helper::Has_value( $this->all_config, "payment_confirm_url" );
        $service    = Variable_helper::Has_value( $this->config, $type."_service" );
        $order_id   = $order->id;

        $request    = ( $type == "card" ? "Mobilpay_Payment_Request_Card" : "Mobilpay_Payment_Request_Sms" );

        $mobilpay_request               = new $request();
        $mobilpay_request->signature    = $signature;

        // creating some url parameters
        $url_parameters                 = "?payment_system=".$this->type;
        // supply return_url and/or confirm_url only if you want to overwrite the ones
        // configured for the service/product when it was created
        $mobilpay_request->returnUrl    = MY_Url_helper::Site_url().$returnUrl.$url_parameters;
        $mobilpay_request->confirmUrl   = MY_Url_helper::Site_url().$confirmUrl.$url_parameters;
        $mobilpay_request->cancelUrl    = MY_Url_helper::Site_url().$cancelUrl.$url_parameters;
        // add the md5 encoded order id
        $mobilpay_request->orderId      = md5( $order->user_id."-".$order_id );

        // Add some parameter to the object
        $params  = array(
            "order_id"            => $order_id,
            "user_id"             => $order->user_id,
            "transaction_type"    => "express",
            "payment_system"      => $this->type,
            "payment_method_type" => $type
        );
        // save the params
        $mobilpay_request->params       = $params;

        Logger_helper::Debug( "Mobilpay payment - params: ".print_r( $params, TRUE ) );

        // merchant account signature - generated by mobilpay.ro for every merchant account
        // www.mobilpay.ro Admin -> Conturi de comerciant -> Detalii -> Setari securitate
        // service/product identificator generated by mobilpay.ro for every service/product
        if( $type == "sms" )
        {
            // www.mobilpay.ro Admin -> Conturi de comerciant -> Produse si servicii -> Semnul plus
            $mobilpay_request->service = $service;
        }
        else
        {
            $mobilpay_request->invoice = new Mobilpay_Payment_Invoice();

            if( empty( $order->currency ) )
            {
                $order->currency = App()->config->currency;
            }
            $mobilpay_request->invoice->currency    = $order->currency;
            $mobilpay_request->invoice->amount      = str_replace( ",", ".", $order->total_price );

            //$objPmReqCard->invoice->installments    = "2,3";
            $mobilpay_request->invoice->details     = "Payment with card";
        }

        // Add the billing address information
        $billingAddress     = new Mobilpay_Payment_Address();

        $user_details       = Variable_helper::Has_value( $order, "user_details" );
        $company_details    = Variable_helper::Has_value( $order, "company_details" );

        // Set the beneficiar
        if( ! empty( $user_details ) )
        {
            $billingAddress->firstName  = $user_details->first_name;
            $billingAddress->lastName   = $user_details->last_name;
            $billingAddress->address    = $user_details->address1." ".$user_details->address2;
        }

        if( $type == "card" )
        {
            if( ! $order->is_company )
            {
                $billingAddress->type         = "person";
                $billingAddress->fiscalNumber = "";
                $billingAddress->country      = Variable_helper::Has_value( $user_details->country, "code" );
                $billingAddress->county       = $user_details->county;
                $billingAddress->city         = $user_details->city;
                $billingAddress->zipCode	  = $user_details->postcode;
                $billingAddress->mobilePhone  = $user_details->phone;
                $billingAddress->email        = $user_details->email;
            }
            else
            {
                $billingAddress->type             = "company";
                $billingAddress->fiscalNumber     = $company_details->cui;
                $billingAddress->identity_number  = $company_details->registry_number;
                $billingAddress->bank             = $company_details->bank;
                $billingAddress->iban             = $company_details->bank_account;
            }

            // Set the billing address, and shipping address
            $mobilpay_request->invoice->setBillingAddress( $billingAddress );
            $mobilpay_request->invoice->setShippingAddress( $billingAddress );

            Logger_helper::Debug( "Mobilpay payment - billing address: ".print_r( $billingAddress, TRUE ) );
            Logger_helper::Debug( "Mobilpay payment - shipping address: ".print_r( $billingAddress, TRUE ) );
        }

        $mobilpay_request->encrypt( $public_key );
        try
        {
        }
        catch( Exception $e )
        {
            Logger_helper::Error( "Mobilpay payment - error encountered while encrypting" );
            throw new MPHP_exception( E_ERROR, "Error while encrypting" );
        }

        // Get the response data
        $this->enc_data   = $mobilpay_request->getEncData();
        $this->env_key    = $mobilpay_request->getEnvKey();

        $this->Set_details_into_data();
    }

    private function Set_details_into_data()
    {
        App()->controller->data["enc_data"]             = $this->enc_data;
        App()->controller->data["env_key"]              = $this->env_key;
        App()->controller->data["payment_url"]          = Variable_helper::Has_value( $this->config, "checkout_url" );
        App()->controller->data["is_redirection_needed"]= 1;
        App()->controller->data["payment_data"]         = '
            <input type="hidden" name="enc_data" value="'.$this->enc_data.'">
            <input type="hidden" name="env_key" value="'.$this->env_key.'">';

        if( ! empty( App()->controller->data["payment_url"] ) )
        {
            Logger_helper::Error( "MobilPay payment - unable to set checkout url, is missing" );
            $this->status = FALSE;
            return FALSE;
        }
    }

    public function Get_express_checkout_details( & $order )
    {
        $this->status           = TRUE;
        $this->correlation_id	= "MobilpaySuccess";

        return $this->Get_status();
    }

    public function Do_express_checkout( & $order )
    {
        Logger_helper::Debug( "Mobilpay payment - do express checkout" );

        if( $order->order_payment_status_id == Config_helper::Get( "order_success_status_id" ) )
        {
            Logger_helper::Info( "Mobilpay payment - express checkout success" );

            $this->status = TRUE;
        }
        else
        {
            Logger_helper::Info( "Mobilpay payment - do express checkout error" );

            $this->status = FALSE;
            $this->error_message = $order->error_text;
        }

        return $this->Get_status();
    }

    public function Do_direct_payment( & $order, $card_details )
    {
        Logger_helper::Debug( "Mobilpay payment - do direct payment started" );
        Logger_helper::Error( "Mobilpay payment - this payment type has not direct payment" );

        return FALSE;
    }

    public function Confirm( & $order )
    {
        $confirm_type = Get_helper::Get( "payment_method_type" );

        if( empty( $confirm_type ) || ! in_array( $confirm_type, $this->available_types ) )
        {
            $confirm_type  = "card";
        }

        // Call the method for selected payment type
        $this->{"Confirm_response_".$confirm_type}( $order );

        return $this->Get_status();
    }

    private function Confirm_response_card( & $order )
    {
        // Set error code
        $error_code = 0;

        $type       = "card";
        $env_key    = Post_helper::Get( "env_key" );
        $data       = Post_helper::Get( "data" );

        // If there is a post, so the mobilpay has sent the confirm details
        if( ! empty( $env_key ) && ! empty( $data ) )
        {
            Logger_helper::Debug( "We got the response from Mobilpay for type: ".$type." and order: ".$order->id );

            $error_type	= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_NONE;

            Logger_helper::Debug( "We got the env_key and data from Mobilpay for order: ".$order->i );

            // Private key was generated at Mobilpay, we can download from
            // Admin -> Conturi de comerciant -> Detalii -> Setari securitate
            $privateKeyFilePath = $this->config[$type."_private_key_file"];

            Logger_helper::Debug( "Private key:".$this->config[$type."_private_key_file"] );

            // try to get the confirmation message
            try
            {
                Logger_helper::Debug( "Try to decrypt the data" );

                $mobilpay_response  = Mobilpay_Payment_Request_Abstract::factoryFromEncrypted(
                    $env_key,
                    $data,
                    $privateKeyFilePath
                );

                $params             = $mobilpay_response->params;
                Logger_helper::Debug( "Mobilpay payment - confirm - parameters received" );

                App()->session->Set( "confirm_params", $params );

                switch( $mobilpay_response->objPmNotify->action )
                {
                    case 'confirmed':
                        Logger_helper::Debug( "Mobilpay payment - Response: Confirmed" );

                        #cand action este confirmed avem certitudinea ca banii au plecat din contul posesorului de card si facem update al starii comenzii si livrarea produsului
                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        if( ! $error_code )
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order payed" );
                        }
                        else
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order deleted by error code: ".$error_code );
                        }
                        break;

                    case 'confirmed_pending':
                        Logger_helper::Debug( "Mobilpay payment - Response: Confirm pending" );

                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        if( ! $error_code )
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order in prcess" );
                        }
                        else
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order deleted by errorcode: ".$error_code );
                        }
                        break;

                    case 'paid_pending':
                        Logger_helper::Debug( "Mobilpay payment - Response: Paid pending" );

                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        if( $error_code )
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order deleted because paid pending" );
                        }
                        break;

                    case 'paid':
                        Logger_helper::Debug( "Mobilpay payment - Response: Paid" );

                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        if( ! $error_code )
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order in process" );
                        }
                        else
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order deleted by error code: ".$error_code );
                        }

                        break;

                    case 'canceled':
                        Logger_helper::Debug( "Mobilpay payment - Response: Cancelled" );

                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        Logger_helper::Debug( "Mobilpay payment - Response: Order deleted because it was cancelled" );
                        break;

                    case 'credit':
                        Logger_helper::Debug( "Mobilpay payment - Response: Credit" );

                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        Logger_helper::Debug( "Mobilpay payment - Response: Order deleted because insufficient credit" );
                        break;

                    default:
                        $error_type		        = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
                        $error_code 	        = Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_ACTION;
                        $this->error_message 	= 'mobilpay_reference_action paramaters is invalid';
                        break;
                }
            }
            catch(Exception $e)
            {
                $error_type 	    = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_TEMPORARY;
                $error_code		    = $e->getCode();
                $this->error_message= $e->getMessage();
            }
        }
        else
        {
            $error_type             = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
            $error_code		        = Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_PARAMETERS;
            $this->error_message 	= 'mobilpay.ro posted invalid parameters';
        }

        return $this->Print_response( $error_code, $error_type );
    }

    private function Print_response( $error_code, $error_type )
    {
        header( 'Content-type: text/xml' );

        /* echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"; */
        $xml_response = '<?xml version="1.0" encoding="utf-8"?>'."\n";

        if( $error_code == 0)
        {
            $this->status = TRUE;

            /* echo "<crc>{$errorMessage}</crc>"; */
            $xml_response .= "<crc>{$this->error_message}</crc>";
        }
        else
        {
            $this->status = FALSE;
            $this->error_message = "Error type: ".$error_type.", error_code: ".$error_code;

            /* echo "<crc error_type=\"{$error_type}\" error_code=\"{$error_code}\">{$errorMessage}</crc>"; */
            $xml_response .= '<crc error_type="'.$error_type.'" error_code="'.$error_code.'">'.$this->error_message.'</crc>';
        }

        echo $xml_response;

        return ! $error_code;
    }

    private function Confirm_response_sms( & $order )
    {
        // Set error code
        $error_code = 0;

        $type       = "card";
        $env_key    = Post_helper::Get( "env_key" );
        $data       = Post_helper::Get( "data" );

        // If there is a post, so the mobilpay has sent the confirm details
        if( ! empty( $env_key ) && ! empty( $data ) )
        {
            Logger_helper::Debug( "We got the response from Mobilpay for type: " . $type . " and order: " . $order->id );

            $error_type	= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_NONE;

            Logger_helper::Debug( "We got the env_key and data from Mobilpay for order: ".$order->i );

            // Private key was generated at Mobilpay, we can download from
            // Admin -> Conturi de comerciant -> Detalii -> Setari securitate
            $privateKeyFilePath = $this->config[$type."_private_key_file"];

            Logger_helper::Debug( "Private key:".$this->config[$type."_private_key_file"] );

            try
            {
                Logger_helper::Debug( "Try to decrypt the data" );

                $mobilpay_response  = Mobilpay_Payment_Request_Abstract::factoryFromEncrypted(
                    $env_key,
                    $data,
                    $privateKeyFilePath
                );

                $params             = $mobilpay_response->params;
                Logger_helper::Debug( "Mobilpay payment - confirm - parameters received" );

                App()->session->Set( "confirm_params", $params );

                switch( $mobilpay_response->objPmNotify->action )
                {
                    case 'confirmed':
                        Logger_helper::Debug( "Mobilpay payment - Response: Confirmed" );

                        #cand action este confirmed avem certitudinea ca banii au plecat din contul posesorului de card si facem update al starii comenzii si livrarea produsului
                        $this->error_message  = $mobilpay_response->objPmNotify->getCrc();
                        $error_code           = $mobilpay_response->objPmNotify->errorCode;

                        if( ! $error_code )
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order payed" );
                        }
                        else
                        {
                            Logger_helper::Debug( "Mobilpay payment - Response: Order deleted by error code: ".$error_code );
                        }
                        break;

                    default:
                        $error_type		        = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
                        $error_code 	        = Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_ACTION;
                        $this->error_message 	= 'mobilpay_reference_action paramaters is invalid';
                        break;
                }
            }
            catch(Exception $e)
            {
                $error_type 	    = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_TEMPORARY;
                $error_code		    = $e->getCode();
                $this->error_message= $e->getMessage();
            }
        }
        else
        {
            $error_type             = Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
            $error_code		        = Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_PARAMETERS;
            $this->error_message 	= 'mobilpay.ro posted invalid parameters';
        }

        return $this->Print_response( $error_code, $error_type );
    }
}

/* End of file Payment_Mobilpay.php */
/* Location: ./core/Libraries/Payments/Mobilpay/ */